this.name        = "lord-of-the-rings"; 
this.author      = "aegidian, (JS translation by eric walch)"; 
this.copyright   = "� 2008 the Oolite team."; 
this.description = "Script for ringpods."; 
this.version     = "1.1.2";

this.beacons = ["1-TRB", "2-TRB", "3-TRB", "4-TRH"];

this.nextRing = 0;
this.start = false;
this.todayHigh = 1000;

this.shipLaunchedFromStation = function ()
{
    if(galaxyNumber == 0 && (system.ID == 7 || system.ID == 129))
	{
		this.lookForRacers();
	}
}


this.ringPassage = function (ship)
{
	if (this.start)
	{
		var time = Math.round((clock.absoluteSeconds - this.startTime)*100)/100;
		if(ship.beaconCode == this.beacons[this.nextRing])
		{
			if (this.nextRing < 3)
				player.commsMessage("Passed ring " + this.beacons[this.nextRing++] + " after "+ time +" seconds.");
			else
			{
				player.commsMessage("Run complete after "+ time +" seconds.", 15);
				log(this.name, "Run complete after "+ time +" seconds.");
				this.nextRing = 0;
				this.start = false;
				// Finished
				if (time < this.todayHigh)
				{
					player.commsMessage("Congratulations: A new today highscore.", 15);
					this.todayHigh = time;
				}
				this.lookForRacers();
			}
		}
		else
		player.commsMessage("Passed the wrong ring. You should go for ring: "+this.beacons[this.nextRing]);
	}
	else
	{
		if (ship.beaconCode == this.beacons[0])
		{
			player.commsMessage("Passed the first ring, time starts running...");
			this.start = true;
			this.startTime = clock.absoluteSeconds;
			this.nextRing++;
			// Starting
		}
		else
		{
			player.commsMessage("Passed the wrong ring. The starting ring is : " + this.beacons[this.nextRing]);
		}
	}
}

this.lookForRacers = function ()
{
	function isLonelyRacer(entity) 
	{ 
		return (entity.isShip && (entity.primaryRole == "trader" || entity.primaryRole == "police") && !entity.escorts);
	}
	var racers = system.filteredEntities(this, isLonelyRacer, system.mainStation, 150E3)
	for (var i=0; i<racers.length; i++)
	{
		if (racers[i].AI == "fttAI.plist") return;
		if (racers[i].AI == "route1traderAI.plist" || racers[i].AI == "planetPatrolAI.plist" || racers[i].AI == "route1patrolAI.plist")
        {
			racers[i].setAI("fttAI.plist");
			log(this.name, "Racer "+racers[i].displayName+" signs on for racing"); return;
		}
	}
}
